include "wsdl.grm"

redefine program 
		...
	|	[repeat fact]
end redefine

define fact
	[repeat id_or_id_dot]																			[NL]
end define 

define id_or_id_dot
		[SPOFF] [id] '. [id] '. [id] [SPON]	[SP]
	|	[SPOFF] [id] '. [id] [SPON]	[SP]
	|	[id] [SP]
end define

function main
	replace [program]
		P [program]
	
	construct Service [repeat service]
		_ [^ P] 
	deconstruct Service
		'< _ [opt prefix] 'service AttrList [opt attribute_list] '>
			_ [repeat service_scope] 
		'</ _ [opt prefix] 'service>
	construct ServiceNameAttr [repeat name_attr]
		_ [^ AttrList]
	deconstruct ServiceNameAttr
		_ [opt prefix] 'name = ServiceNameWithPrefix [stringlit] 
		_ [repeat name_attr]
	construct ServiceNameNoPrefix [stringlit] 
		ServiceNameWithPrefix [deletePrefix]
	construct ServiceNameID [id] 
		_ [unquote ServiceNameNoPrefix]
	construct Facts [repeat fact]
		ServiceNameID
			
	by 
		Facts
end function 

function deletePrefix 
	replace [stringlit]
		NameWithPrefix [stringlit]
	construct IndexOfColon [number]
		_ [index NameWithPrefix ":"] [+ '1]
	deconstruct not IndexOfColon
		1
	by
		NameWithPrefix [: IndexOfColon 999]
end function
